## git-subrepo 0.4.6

=== Makefile ===
SHELL := bash

# Make sure we have git:
ifeq ($(shell which git),)
  $(error 'git' is not installed on this system)
endif

# Set variables:
NAME := git-subrepo
LIB  := lib/$(NAME)
DOC  := doc/$(NAME).swim
MAN1 := man/man1
EXT  := $(LIB).d
EXTS := $(shell find $(EXT) -type f) \
	$(shell find $(EXT) -type l)
SHARE = share

# Install variables:
PREFIX ?= /usr/local
INSTALL_LIB  ?= $(DESTDIR)$(shell git --exec-path)
INSTALL_EXT  ?= $(INSTALL_LIB)/$(NAME).d
INSTALL_MAN1 ?= $(DESTDIR)$(PREFIX)/share/man/man1

# Docker variables:
DOCKER_TAG ?= 0.0.4
DOCKER_IMAGE := ingy/bash-testing:$(DOCKER_TAG)
BASH_VERSIONS ?= 5.1 5.0 4.4 4.3 4.2 4.1 4.0
DOCKER_TESTS := $(BASH_VERSIONS:%=docker-test-%)
GIT_VERSIONS := 2.29 2.25 2.17 2.7

prove ?=
test ?= test/
bash ?= 5.0
git ?= 2.29

# Basic targets:
default: help

help:
	@echo 'Makefile rules:'
	@echo ''
	@echo 'test       Run all tests'
	@echo 'install    Install $(NAME)'
	@echo 'uninstall  Uninstall $(NAME)'
	@echo 'env        Show environment variables to set'

.PHONY: test
test:
	prove $(prove) $(test)

test-all: test docker-tests

docker-test:
	$(call docker-make-test,$(bash),$(git))

docker-tests: $(DOCKER_TESTS)

$(DOCKER_TESTS):
	$(call docker-make-test,$(@:docker-test-%=%),$(git))

# Install support:
install:
	install -d -m 0755 $(INSTALL_LIB)/
	install -C -m 0755 $(LIB) $(INSTALL_LIB)/
	install -d -m 0755 $(INSTALL_EXT)/
	install -C -m 0755 $(EXTS) $(INSTALL_EXT)/
	install -d -m 0755 $(INSTALL_MAN1)/
	install -C -m 0644 $(MAN1)/$(NAME).1 $(INSTALL_MAN1)/

# Uninstall support:
uninstall:
	rm -f $(INSTALL_LIB)/$(NAME)
	rm -fr $(INSTALL_EXT)
	rm -f $(INSTALL_MAN1)/$(NAME).1

env:
	@echo "export PATH=\"$$PWD/lib:\$$PATH\""
	@echo "export MANPATH=\"$$PWD/man:\$$MANPATH\""

# Doc rules:
.PHONY: doc
update: doc compgen

force:

doc: ReadMe.pod Intro.pod $(MAN1)/$(NAME).1
	perl pkg/bin/generate-help-functions.pl $(DOC) > \
	    $(EXT)/help-functions.bash

ReadMe.pod: $(DOC) force
	swim --to=pod --wrap --complete $< > $@

Intro.pod: doc/intro-to-subrepo.swim force
	swim --to=pod --wrap --complete $< > $@

$(MAN1)/%.1: doc/%.swim Makefile force
	swim --to=man --wrap $< > $@

compgen: force
	perl pkg/bin/generate-completion.pl bash $(DOC) $(LIB) > \
	    $(SHARE)/completion.bash
	perl pkg/bin/generate-completion.pl zsh $(DOC) $(LIB) > \
	    $(SHARE)/zsh-completion/_git-subrepo

clean:
	rm -fr tmp test/tmp

define docker-make-test
	docker run -i -t --rm \
	    -v $(PWD):/git-subrepo \
	    -w /git-subrepo \
	    $(DOCKER_IMAGE) \
		/bin/bash -c ' \
		    set -x && \
		    [[ -d /bash-$(1) ]] && \
		    [[ -d /git-$(2) ]] && \
		    export PATH=/bash-$(1)/bin:/git-$(2)/bin:$$PATH && \
		    bash --version && \
		    git --version && \
		    make test prove=$(prove) test=$(test) \
		'
endef

=== debian/changelog ===
git-subrepo (0.4.6-1) unstable; urgency=medium

  * Initial release. (Closes: #911397)

 -- Samo Pogačnik <samo_pogacnik@t-2.net>  Fri, 21 Jun 2024 14:12:22 +0000

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1
export PREFIX=/usr
export INSTALL_LIB=$(DESTDIR)/usr/share/git-subrepo
export INSTALL_EXT=$(INSTALL_LIB)

%:
	dh $@ \
	  -Smakefile --with=bash-completion

## TODO: Tests cause unclean buildtree
override_dh_auto_test:
	true
#ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
#	make test
#endif

override_dh_installchangelogs:
	dh_installchangelogs Changes

## git-subrepo 0.4.9

=== Makefile ===
--- 
+++ 
@@ -22,16 +22,16 @@
 INSTALL_MAN1 ?= $(DESTDIR)$(PREFIX)/share/man/man1
 
 # Docker variables:
-DOCKER_TAG ?= 0.0.4
+DOCKER_TAG ?= 0.0.6
 DOCKER_IMAGE := ingy/bash-testing:$(DOCKER_TAG)
 BASH_VERSIONS ?= 5.1 5.0 4.4 4.3 4.2 4.1 4.0
 DOCKER_TESTS := $(BASH_VERSIONS:%=docker-test-%)
-GIT_VERSIONS := 2.29 2.25 2.17 2.7
+GIT_VERSIONS := 2.45 2.40 2.30 2.29 2.25 2.17 2.7
 
 prove ?=
 test ?= test/
-bash ?= 5.0
-git ?= 2.29
+bash ?= 5.1
+git ?= 2.45
 
 # Basic targets:
 default: help
@@ -63,7 +63,7 @@
 	install -d -m 0755 $(INSTALL_LIB)/
 	install -C -m 0755 $(LIB) $(INSTALL_LIB)/
 	install -d -m 0755 $(INSTALL_EXT)/
-	install -C -m 0755 $(EXTS) $(INSTALL_EXT)/
+	install -C -m 0644 $(EXTS) $(INSTALL_EXT)/
 	install -d -m 0755 $(INSTALL_MAN1)/
 	install -C -m 0644 $(MAN1)/$(NAME).1 $(INSTALL_MAN1)/
 
@@ -106,7 +106,7 @@
 	rm -fr tmp test/tmp
 
 define docker-make-test
-	docker run -i -t --rm \
+	docker run --rm \
 	    -v $(PWD):/git-subrepo \
 	    -w /git-subrepo \
 	    $(DOCKER_IMAGE) \

=== ext/bashplus/Makefile ===
ifeq ($(MAKECMDGOALS),install)
  ifeq "$(shell bpan version 2>/dev/null)" ""
    $(error 'BPAN not installed. See http://bpan.org')
  endif
endif

NAME := bash+
LIB  := lib/$(NAME).bash
DOC  := doc/$(NAME).swim
MAN1 := man/man1
MAN3 := man/man3

INSTALL_LIB  ?= $(shell bpan env BPAN_LIB)
INSTALL_DIR  ?= test
INSTALL_MAN1 ?= $(shell bpan env BPAN_MAN1)
INSTALL_MAN3 ?= $(shell bpan env BPAN_MAN3)

DOCKER_IMAGE := ingy/bash-testing:0.0.1
DOCKER_TESTS := 5.1 5.0 4.4 4.3 4.2 4.1 4.0 3.2
DOCKER_TESTS := $(DOCKER_TESTS:%=docker-test-%)

default: help

help:
	@echo 'Rules: test, install, doc'

.PHONY: test
test:
	prove $(PROVEOPT:%=% )test/

test-all: test docker-test

docker-test: $(DOCKER_TESTS)

$(DOCKER_TESTS):
	$(call docker-make-test,$(@:docker-test-%=%))

install:
	install -C -d -m 0755 $(INSTALL_LIB)/$(INSTALL_DIR)/
	install -C -m 0755 $(LIB) $(INSTALL_LIB)/$(INSTALL_DIR)/
	install -C -d -m 0755 $(INSTALL_MAN1)/
	install -C -d -m 0755 $(INSTALL_MAN3)/
	install -C -m 0644 $(MAN1)/$(NAME).1 $(INSTALL_MAN1)/
	install -C -m 0644 $(MAN3)/$(NAME).3 $(INSTALL_MAN3)/

.PHONY: doc
doc: ReadMe.pod $(MAN1)/$(NAME).1 $(MAN3)/$(NAME).3

ReadMe.pod: $(DOC)
	swim --to=pod --complete --wrap $< > $@

$(MAN1)/%.1: doc/%.swim
	swim --to=man $< > $@

$(MAN3)/%.3: doc/%.swim
	swim --to=man $< > $@

define docker-make-test
	docker run -i -t --rm \
	    -v $(PWD):/git-subrepo \
	    -w /git-subrepo \
	    $(DOCKER_IMAGE) \
		/bin/bash -c ' \
		    set -x && \
		    [[ -d /bash-$(1) ]] && \
		    export PATH=/bash-$(1)/bin:$$PATH && \
		    bash --version && \
		    make test \
		'
endef

=== ext/test-more-bash/Makefile ===
NAME := test-more
DOC  := doc/$(NAME).swim
MAN3 := man/man3

DOCKER_IMAGE := ingy/bash-testing:0.0.1
DOCKER_TESTS := 5.1 5.0 4.4 4.3 4.2 4.1 4.0 3.2
DOCKER_TESTS := $(DOCKER_TESTS:%=docker-test-%)

default: help

help:
	@echo 'Rules: test, doc'

.PHONY: test
test:
	prove $(PROVEOPT:%=% )test/

test-all: test docker-test

docker-test: $(DOCKER_TESTS)

$(DOCKER_TESTS):
	$(call docker-make-test,$(@:docker-test-%=%))

doc: ReadMe.pod $(MAN3)/$(NAME).3

ReadMe.pod: $(DOC)
	swim --to=pod --complete --wrap $< > $@

$(MAN3)/%.3: doc/%.swim
	swim --to=man $< > $@

define docker-make-test
	docker run -i -t --rm \
	    -v $(PWD):/git-subrepo \
	    -w /git-subrepo \
	    $(DOCKER_IMAGE) \
		/bin/bash -c ' \
		    set -x && \
		    [[ -d /bash-$(1) ]] && \
		    export PATH=/bash-$(1)/bin:$$PATH && \
		    bash --version && \
		    make test \
		'
endef

=== ext/test-more-bash/ext/test-tap-bash/Makefile ===
SHELL := bash

ifeq ($(MAKECMDGOALS),install)
  ifeq "$(shell bpan version 2>/dev/null)" ""
    $(error 'BPAN not installed. See http://bpan.org')
  endif
endif

NAME := test-tap
LIB  := lib/test/tap.bash
MAN3 := man/man3

INSTALL_LIB  ?= $(shell bpan env BPAN_LIB)
INSTALL_DIR  ?= test
INSTALL_MAN3 ?= $(shell bpan env BPAN_MAN3)

DOCKER_IMAGE := ingy/bash-testing:0.0.1

default: help

help:
	@echo 'Rules: test, install, doc'

.PHONY: test
test:
	prove $(PROVEOPT:%=% )test/

test-all: test docker-test

docker-test:
	-$(call docker-make-test,3.2)
	-$(call docker-make-test,4.0)
	-$(call docker-make-test,4.1)
	-$(call docker-make-test,4.2)
	-$(call docker-make-test,4.3)
	-$(call docker-make-test,4.4)
	-$(call docker-make-test,5.0)
	-$(call docker-make-test,5.1)

install:
	install -C -d -m 0755 $(INSTALL_LIB)/$(INSTALL_DIR)/
	install -C -m 0755 $(LIB) $(INSTALL_LIB)/$(INSTALL_DIR)/
	install -C -d -m 0755 $(INSTALL_MAN3)/
	install -C -m 0644 $(MAN3)/$(NAME).3 $(INSTALL_MAN3)/

.PHONY: doc
doc: ReadMe.pod $(MAN3)/$(NAME).3

ReadMe.pod: doc/test-tap.swim
	swim --to=pod --complete --wrap $< > $@

man/man3/%.3: doc/%.swim
	swim --to=man $< > $@

define docker-make-test
	docker run -i -t --rm \
	    -v $(PWD):/git-subrepo \
	    -w /git-subrepo \
	    $(DOCKER_IMAGE) \
		/bin/bash -c ' \
		    set -x && \
		    [[ -d /bash-$(1) ]] && \
		    export PATH=/bash-$(1)/bin:$$PATH && \
		    bash --version && \
		    make test \
		'
endef

=== debian/changelog ===
git-subrepo (0.4.9-2) unstable; urgency=medium

  * Reordered and rewritten existing patches (Closes: #1078960)
  * Added patches to fix upstream PR checks:
    - 0005-Fixing-shellcheck-errors-found-during-docker-test.patch
    - 0006-Fixing-tests-running-on-macos-github.patch
  * Added patch to set project-wide ff_only git-config for pull and merge
    during tests:
    - 0007-Set-project-wide-ff_only-git-config-for-pull-and-mer.patch
  * Added patch to fix git-subrepo command and its tests, when ff=only is
    set in git-config:
    - 0008-Fixed-git-subrepo-and-tests-if-set-ff_only.patch
  * d/control: update Standards-Version to 4.7.0
  * d/control: bump debhelper compat level to 13
  * d/control: added Multi-Arch: same
  * Acknowledge the previous upload (Closes: #1081945)
  * d/copyright: extended copyright year for debian/* files
  * Added d/upstream/metadata

 -- Samo Pogačnik <samo_pogacnik@t-2.net>  Sun, 16 Feb 2025 19:37:05 +0000

git-subrepo (0.4.9-1) unstable; urgency=medium

  * Updated debian/patches against 0.4.9 upstream
  * Fixed broken test in 0.4.9 upstream release

 -- Samo Pogačnik <samo_pogacnik@t-2.net>  Wed, 23 Oct 2024 19:53:02 +0000

git-subrepo (0.4.6-2) unstable; urgency=medium

  [ Samo Pogačnik ]
  * Allow running tests outside Makefile
  * d/rules: re-enabled upstream testsuite
  * d/rules: moving/restoring binary test repos
  * Disabling any system/global GIT configuration for tests
  * d/rules: added option for verbose tests execution

 -- Daniel Gröber <dxld@darkboxed.org>  Sat, 12 Oct 2024 16:47:41 +0200

=== debian/control ===
Source: git-subrepo
Section: vcs
Priority: optional
Homepage: https://github.com/ingydotnet/git-subrepo
Vcs-Browser: https://salsa.debian.org/debian/git-subrepo
Vcs-Git: https://salsa.debian.org/debian/git-subrepo.git
Maintainer: Samo Pogačnik <samo_pogacnik@t-2.net>
Build-Depends:
 debhelper-compat (= 13),
 debhelper (>= 13),
 git,
 bash-completion,
 less
Rules-Requires-Root: no
Standards-Version: 4.7.0

Package: git-subrepo
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, git
Description: Alternative to git-submodule(1) and git-subtree(1)
 git-subrepo allows embedding and managing copies of other git repositories
 in your repo for purposes such as vendoring.
 .
 Commits in the parent repo involving the subrepo can easily be pushed back
 upstream even when they touch files outside the subrepo -- these will simply
 be omitted.
 .
 Pulling new upstream commits back into your repo is naturally also possible.
 .
 git-subrepo is designed such that only the maintainer of a repo will
 actually need to have it installed, contributors only need to do so if
 they wish to push/pull from the subrepo's upstream and user should never
 have to interact with git-subrepo at all since all of a subrepos file are
 available right after a plain git-clone.
 .
 This is unlike git-submodule(1)s where all users and contributors must be
 aware of their presence and deal with them.
 .
 git-subrepo is in principle somewhat similar to git-subtree(1) as it also
 embedds snapshot copies of other repos, however it is much easier to use
 and the way the history is kept is less convoluted. Pulling any number of
 new commits from a subrepo's upstream will result in only a single commit
 in the parent repo for example.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1
#export DH_OPTIONS = -v
# PROVE_OPTIONS: Set testing suite options (i.e. verbose output)
#export PROVE_OPTIONS = -v
export PREFIX=/usr
export INSTALL_LIB=$(DESTDIR)/usr/share/git-subrepo
export INSTALL_EXT=$(INSTALL_LIB)

%:
	dh $@ \
	  -Smakefile --with=bash-completion

override_dh_auto_clean:
	@if [ ! -d "test/repo_orig" ]; then \
		echo "MOVE ORIGINAL BIANRY REPOS"; \
		mv test/repo test/repo_orig; \
	else \
		echo "ORIGINAL BINARY REPOS ALREADY MOVED"; \
	fi
	make clean
	@if [ -d "test/repo_orig" ]; then \
		echo "RESTORE ORIGINAL BINARY REPOS"; \
		rm -rf test/repo; \
		mv test/repo_orig test/repo; \
	else \
		echo "NOTHING TO RESTORE - ORIGINAL BINARY REPOS NOT MOVED"; \
	fi

override_dh_auto_test:
	@if [ ! -d "test/repo_orig" ]; then \
		echo "MOVE ORIGINAL BIANRY REPOS"; \
		mv test/repo test/repo_orig; \
	else \
		echo "ORIGINAL BINARY REPOS ALREADY MOVED"; \
	fi
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	export prove=$(PROVE_OPTIONS); make test
endif

override_dh_installchangelogs:
	dh_installchangelogs Changes

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/(\d\.[0-9.]+)\.tar\.gz/git-subrepo-$1\.tar\.gz/ \
  https://github.com/ingydotnet/git-subrepo/tags .*/(\d\.[0-9.]+)\.tar\.gz
